#pragma once

// Set to 1 to register from main.cpp file. Then everything is OK
#define CLASS_EXPORT_IN_MAIN 0

#include <stdio.h>
#include <tchar.h>
#include <crtdbg.h>

#include "fstream"

#include <boost/archive/text_oarchive.hpp>
#include <boost/archive/text_iarchive.hpp>
#include <boost/serialization/export.hpp>
#include <boost/serialization/base_object.hpp>

class Base abstract
{
  friend class boost::serialization::access;
  template<class Archive>
  void serialize(Archive & ar, const unsigned int version) {
  }
public:
  virtual ~Base(){}
};

class Object : public Base {
  friend class boost::serialization::access;
  template<class Archive>
  void serialize(Archive & ar, const unsigned int version) {
    ar & boost::serialization::base_object<Base>(*this);
  }
};

class Main : public Base {
  friend class boost::serialization::access;
  template<class Archive>
  void serialize(Archive & ar, const unsigned int version) {
    ar & boost::serialization::base_object<Base>(*this);
    ar & m_pObj;
    ar & m_obj;
  }

public:

  Base*
    m_pObj;
  Object
    m_obj;

  Main(
  )
  {
    m_pObj = new Object();
  }

};